blob: 5796c2879ea58fcdad424bd967a9f2956be78187 [file] [log] [blame]
Petr Michalec1ed1b3c2017-08-08 19:19:01 +02001#!/bin/bash -e
2
3# bootstrap.sh
4
5# Installs Salt and configure minimal SaltMaster or Minion to be used with:
6# - http://github.com/salt-formulas-scripts
7# - http://github.com/salt-formulas/salt-formula-salt (salt.master sls)
8
Petr Michalecb3120042018-03-17 11:17:32 +01009# NOTE: This script is collection of shared functions to automate bootstrap of "salted" CI environments.
10# Its not intended to be used in PRODUCTION unless you know what you are doing.
11# You have been warned!
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020012
azvyagintsev90896152019-02-26 15:42:18 +020013__ScriptVersion="2019.02.26"
azvyagintseve93f8372018-09-12 16:50:58 +030014__ScriptName="bootstrap.sh"
15__ScriptFullName="$0"
16__ScriptArgs="$*"
17
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020018# Source specific env vars.
19# shopt -u dotglob
20export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass}
21function source_local_envs() {
Petr Michalecb444ef92017-08-17 13:53:14 +020022 for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do
Vasyl Saienko7a4161c2017-08-14 17:43:15 +030023 for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do
24 echo "Sourcing env variables from $f"
25 source $f
26 done
27 done
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020028}
29source_local_envs
30
31##########################################
32# Set defaults env variables
33
34if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
35 set -x
36 SALT_LOG_LEVEL="--state-verbose=true -ldebug"
37fi
38
39export MAGENTA='\033[0;95m'
40export YELLOW='\033[1;33m'
41export BLUE='\033[0;35m'
42export CYAN='\033[0;96m'
43export RED='\033[0;31m'
44export NC='\033[0m' # No Color'
45
46export LC_ALL=C
47export SALT_LOG_LEVEL="--state-verbose=false -lerror"
48export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }"
49export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020050
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020051# salt apt repository
52test -e /etc/lsb-release && eval $(cat /etc/lsb-release)
53which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)}
54#
Vasyl Saienko70069c82018-12-15 14:11:53 +020055export APT_REPOSITORY=${APT_REPOSITORY:- deb [arch=amd64] http://mirror.mirantis.com/${DISTRIB_REVISION:-testing}/salt-formulas/${DISTRIB_CODENAME} ${DISTRIB_CODENAME} main}
56export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://mirror.mirantis.com/${DISTRIB_REVISION:-testing}/salt-formulas/${DISTRIB_CODENAME}/archive-salt-formulas.key}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020057# reclass
58export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git
ibumarskovf72e05e2017-11-29 14:37:48 +030059export RECLASS_BRANCH=${RECLASS_BRANCH:-master}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020060
61# formula
62export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas}
63export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas}
64export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master}
65export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git
Petr Michalec515356f2017-11-16 11:20:20 +010066# Essential set of formulas (known to by used on cfg01 node for most setups during bootsrap)
67# DEPRECATED: FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS maas memcached ntp nginx collectd sensu heka sphinx mysql grafana libvirt rsyslog glusterfs postfix xtrabackup freeipa prometheus telegraf elasticsearch kibana rundeck devops-portal rsync docker keepalived aptly jenkins gerrit artifactory influxdb horizon}
azvyagintseve93f8372018-09-12 16:50:58 +030068FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- "$EXTRA_FORMULAS"}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020069# minimal set of formulas for salt-master bootstrap
azvyagintseve93f8372018-09-12 16:50:58 +030070declare -a FORMULAS_SALT_MASTER=(reclass salt git openssh linux $(echo "${FORMULAS_SALT_MASTER}"))
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020071export FORMULAS_SALT_MASTER
72
azvyagintseva7a91d52018-09-13 12:58:39 +030073
74# Install 'salt-formula-*'. Works only with FORMULAS_SOURCE==pkg
75export EXTRA_FORMULAS_PKG_ALL=${EXTRA_FORMULAS_PKG_ALL:-False}
76
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020077# system / host
Petr Michalecc749e862017-09-06 21:10:10 +020078export HOSTNAME=${HOSTNAME:-`hostname -s`}
79export HOSTNAME=${HOSTNAME//.*/}
80export DOMAIN=${DOMAIN:-`hostname -d`}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020081export DOMAIN=${DOMAIN:-bootstrap.local}
82
83# salt
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020084export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}}
Petr Michalec2e3a4992017-08-17 14:20:43 +020085export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}}
azvyagintseve3f6f402018-08-23 17:21:49 +030086# Ignore state.apply salt.master.env error
87export SA_IGNORE_ERROR_SALT_MASTER_ENV=${SA_IGNORE_ERROR_SALT_MASTER_ENV:-False}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020088
89# saltstack
Petr Michalec33c04892017-09-08 15:10:30 +020090BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
alexz0adc2712018-02-11 17:33:52 +010091BOOTSTRAP_SALTSTACK_COM=${BOOTSTRAP_SALTSTACK_COM:-"https://bootstrap.saltstack.com"}
Martin Polreich16673dd2018-04-20 12:08:56 +020092BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION:- stable 2017.7 }
Jakub Josef0b611742018-01-09 17:02:01 +010093BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION//latest*/stable}
alexz0adc2712018-02-11 17:33:52 +010094# TODO add 'r' option by default
95# Currently, without 'r' option, upstream saltstack repos will be used. Otherwise
Vasyl Saienko28e3d462018-12-14 17:27:15 +020096# local one should be used, from http://mirror.mirantis.com/ or whatever.
Vasyl Saienko48a10bb2018-11-29 10:17:09 +000097BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX $BOOTSTRAP_SALTSTACK_VERSION }
Petr Michalece11cf612017-09-08 18:21:48 +020098SALT_SOURCE=${SALT_SOURCE:-pkg}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020099
Petr Michalecb3120042018-03-17 11:17:32 +0100100# SECURITY
Petr Michalecca2471f2018-03-17 11:17:32 +0100101SSH_STRICTHOSTKEYCHECKING=no
Petr Michalecb3120042018-03-17 11:17:32 +0100102
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200103# environment
104if [ "$FORMULAS_SOURCE" == "git" ]; then
105 SALT_ENV=${SALT_ENV:-dev}
106elif [ "$FORMULAS_SOURCE" == "pkg" ]; then
107 SALT_ENV=${SALT_ENV:-prd}
108fi
Petr Michalec05b52452017-09-08 14:26:59 +0200109eval "$(grep -h '=' /etc/*release 2> /dev/null)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200110PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z)
111case $PLATFORM_FAMILY in
112 debian )
113 PKGTOOL="$SUDO apt-get"
114 test ${VERSION_ID//\.*/} -ge 16 && {
115 SVCTOOL=service
116 } || { SVCTOOL=service
117 }
118 ;;
119 rhel )
120 PKGTOOL="$SUDO yum"
121 test ${VERSION_ID//\.*/} -ge 7 && {
122 SVCTOOL=systemctl
123 } || { SVCTOOL=service
124 }
125 ;;
126esac
127
128export PLATFORM_FAMILY
129export PKGTOOL
130export SVCTOOL
131
132##########################################
133# FUNCTIONS
134
135log_info() {
136 echo -e "${YELLOW}[INFO] $* ${NC}"
137}
138
139log_warn() {
140 echo -e "${MAGENTA}[WARN] $* ${NC}"
141}
142
Petr Michalec24b30e82017-08-21 10:59:18 +0200143log_debug() {
144 echo -e "${CYAN}[WARN] $* ${NC}"
145}
146
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200147log_err() {
148 echo -e "${RED}[ERROR] $* ${NC}" >&2
149}
150
151configure_pkg_repo()
152{
Vasyl Saienko48a10bb2018-11-29 10:17:09 +0000153
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200154 case $PLATFORM_FAMILY in
155 debian)
156 if [ -n "$APT_REPOSITORY_PPA" ]; then
157 which add-apt-repository || $SUDO apt-get install -y software-properties-common
158 $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA}
Vasyl Saienko48a10bb2018-11-29 10:17:09 +0000159 else
160 echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/mcp_salt.list >/dev/null
161 curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add -
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200162 fi
163 $SUDO apt-get clean
164 $SUDO apt-get update
165 ;;
166 rhel)
167 $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm
168 $SUDO yum clean all
169 ;;
170 esac
171
172}
173
174_atexit() {
175 RETVAL=$?
176 trap true INT TERM EXIT
177
178 if [ $RETVAL -ne 0 ]; then
179 log_err "Execution failed"
180 else
181 log_info "Execution successful"
182 fi
183 return $RETVAL
184}
185
186retry() {
187 local tries
188 if [[ $1 =~ ^[0-9]+$ ]]; then
189 tries=$1; shift
190 else
191 tries=3
192 fi
Petr Michalec262e3ad2017-10-06 13:41:58 +0200193 ret=1
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200194 for i in $(seq 1 $tries); do
Petr Michalec262e3ad2017-10-06 13:41:58 +0200195 "$@" && return $? || ret=$?
196 sleep $i
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200197 done
Petr Michalec9fec8b32017-10-05 14:46:42 +0200198 return $ret
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200199}
200
201function clone_reclass() {
Petr Michaleca361d4e2017-09-08 11:38:16 +0200202 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200203 # No reclass at all, clone from given address
alexz0adc2712018-02-11 17:33:52 +0100204 # In case, non-github repo
205 _tmp_host=$(echo ${RECLASS_ADDRESS} | awk -F/ '{print $3}')
206 ssh-keyscan -T 1 -H ${_tmp_host} >> ~/.ssh/known_hosts || true
207 # But, awk is not perfect solution, so lets make double-check for github
208 ssh-keyscan -T 1 -H github.com >> ~/.ssh/known_hosts || true
ibumarskovf72e05e2017-11-29 14:37:48 +0300209 if echo ${RECLASS_BRANCH} | egrep -q "^refs"; then
210 git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT}
211 cd ${RECLASS_ROOT}
212 git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH} && git checkout FETCH_HEAD
213 export RECLASS_REVISION=$(git rev-parse HEAD)
214 cd -
215 else
216 git clone -b ${RECLASS_BRANCH} ${RECLASS_ADDRESS} ${RECLASS_ROOT};
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200217 fi;
218 fi;
Petr Michalec679f15b2017-09-18 16:16:29 +0200219 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michaleca361d4e2017-09-08 11:38:16 +0200220 log_err "Reclass ${RECLASS_ROOT} is not fetched locally;"
221 ls -Rla ${RECLASS_ROOT}
222 exit 1
223 fi;
224 $SUDO mkdir -p $RECLASS_ROOT/classes/service
225 $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200226}
227
228
229##########################################
230# Main calls
231
Petr Michalecca2471f2018-03-17 11:17:32 +0100232ci_config_ssh() {
233
234 # for CI current user
Petr Michalecb3120042018-03-17 11:17:32 +0100235 conf=~/.ssh/config
236 mkdir -p $(dirname $conf)
237 touch $conf
Petr Michalecca2471f2018-03-17 11:17:32 +0100238 echo -e "Host *\n\tStrictHostKeyChecking $SSH_STRICTHOSTKEYCHECKING\n" | tee -a $conf >/dev/null
Petr Michalecb3120042018-03-17 11:17:32 +0100239 touch ~/.ssh/known_hosts
Petr Michalecca2471f2018-03-17 11:17:32 +0100240
Petr Michalecda014202017-08-18 11:26:07 +0200241 if ! grep github.com ~/.ssh/known_hosts; then
242 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
Petr Michalecb3120042018-03-17 11:17:32 +0100243 ssh-keyscan -H gitlab.com >> ~/.ssh/known_hosts || true
Petr Michalecda014202017-08-18 11:26:07 +0200244 fi
Petr Michalecb3120042018-03-17 11:17:32 +0100245
246 # for root
247 #conf=/root/.ssh/config
248 #$SUDO mkdir -p $(dirname $conf)
249 #$SUDO touch $conf
250 #if ! $SSH_STRICTHOSTKEYCHECKING; then
251 # echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee -a $conf >/dev/null
252 #fi
Petr Michalecda014202017-08-18 11:26:07 +0200253}
254
Petr Michalecca2471f2018-03-17 11:17:32 +0100255# DEPRECATED
256system_config_ssh_conf() {
257 # for backward compatibility
258 ci_config_ssh
Petr Michalecda014202017-08-18 11:26:07 +0200259}
260
261system_config_salt_modules_prereq() {
262 # salt-formulas custom modules dependencies, etc:
Petr Ruzickade2cd3b2017-12-07 14:41:20 +0100263 $SUDO $PKGTOOL install -y apt-transport-https curl git iproute2 openssh-client python-psutil python-apt python-m2crypto python-oauth python-pip sudo &>/dev/null
Petr Michalecda014202017-08-18 11:26:07 +0200264}
265
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200266system_config_minion() {
267 log_info "System configuration salt minion"
268}
269
270system_config_master() {
271 log_info "System configuration salt master"
272
Petr Michalecda014202017-08-18 11:26:07 +0200273 system_config_salt_modules_prereq
Petr Michalecca2471f2018-03-17 11:17:32 +0100274 ci_config_ssh
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200275
Petr Michalecda014202017-08-18 11:26:07 +0200276 if ! grep '127.0.1.2.*salt' /etc/hosts; then
277 echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null
278 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200279}
280
281configure_salt_master()
282{
283
284 echo "Configuring salt-master ..."
285
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200286 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
Petr Michalec29d3ea32017-10-31 17:22:36 +0100287 read -d '' IGNORE_CLASS_NOTFOUND <<-EOF
288 ignore_class_notfound: True
289 ignore_class_regexp:
290 - 'service.*'
291EOF
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200292 fi
293
Petr Michalecdd1a0472017-09-06 19:27:24 +0200294 # to force alternative reclass module path
Petr Michalecd9d0a322017-09-06 19:38:32 +0200295 if [ -n "$RECLASS_SOURCE_PATH" ]; then
296 RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}"
297 else
298 RECLASS_SOURCE_PATH=""
299 fi
Petr Michalecdd1a0472017-09-06 19:27:24 +0200300
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200301 [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d
302 cat <<-EOF > /etc/salt/master.d/master.conf
303 file_roots:
304 base:
305 - /usr/share/salt-formulas/env
306 prd:
307 - /srv/salt/env/prd
308 dev:
309 - /srv/salt/env/dev
310 pillar_opts: False
311 open_mode: True
312 reclass: &reclass
313 storage_type: yaml_fs
314 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200315 ${IGNORE_CLASS_NOTFOUND}
Petr Michalecdd1a0472017-09-06 19:27:24 +0200316 ${RECLASS_SOURCE_PATH}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200317 ext_pillar:
318 - reclass: *reclass
azvyagintsev11927a62019-02-11 12:28:52 +0200319 - gpg: {}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200320 master_tops:
321 reclass: *reclass
322EOF
323
324 echo "Configuring reclass ..."
325
326 [ ! -d /etc/reclass ] && mkdir /etc/reclass
327 cat <<-EOF > /etc/reclass/reclass-config.yml
328 storage_type: yaml_fs
329 pretty_print: True
330 output: yaml
331 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200332EOF
333
334 clone_reclass
335 # override some envs from cluster level *.env, use with care
336 source_local_envs
337
338 cd ${RECLASS_ROOT}
339 if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then
340 # Possibly subrepo checkout needed
341 git submodule update --init --recursive
342 fi
343
Petr Michalec212cc6a2017-08-17 21:39:40 +0200344 mkdir -vp ${RECLASS_ROOT}/nodes/_generated
Petr Michalec51ece842017-09-06 20:44:15 +0200345
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200346 CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1)
Petr Michalec212cc6a2017-08-17 21:39:40 +0200347 CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200348 if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then
Petr Michalec24b30e82017-08-21 10:59:18 +0200349 log_warn "Salt Master node specification has not been found in model."
350 log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200351 cat <<-EOF > ${CONFIG}
352 classes:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200353 - cluster.${CLUSTER_NAME}.infra.config
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200354 parameters:
355 _param:
Petr Michaleca7de6df2017-08-31 12:16:57 +0200356 salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200357 salt_master_base_environment: $SALT_ENV
Petr Michalecd81d1f52017-08-17 20:18:06 +0200358 salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master}
ibumarskovf72e05e2017-11-29 14:37:48 +0300359 reclass_data_revision: ${RECLASS_REVISION:-$RECLASS_BRANCH}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200360 reclass_data_repository: "$RECLASS_ADDRESS"
Petr Michaleca7de6df2017-08-31 12:16:57 +0200361 reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200362 linux_system_codename: ${DISTRIB_CODENAME}
363 cluster_name: ${CLUSTER_NAME}
364 cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200365 linux:
366 system:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200367 name: ${HOSTNAME:-cfg01}
368 domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200369 # ########
370EOF
371
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200372 cat <<-EOF >> ${CONFIG}
373 salt:
374 master:
375 accept_policy: open_mode
376 source:
377 engine: $SALT_SOURCE
azvyagintsev11927a62019-02-11 12:28:52 +0200378 ext_pillars:
379 100_gpg_pillar_renderer:
380 module: gpg
381 params: {}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200382 minion:
383 source:
384 engine: $SALT_SOURCE
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200385 # ########
386 # vim: ft=yaml sw=2 ts=2 sts=2
387EOF
388 fi
Petr Michalec24b30e82017-08-21 10:59:18 +0200389
390 log_debug "Salt Master node config yaml:"
391 log_debug "$(cat ${CONFIG})"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200392}
393
394configure_salt_minion()
395{
396 [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d
397 cat <<-EOF > /etc/salt/minion.d/minion.conf
Petr Michaleca7de6df2017-08-31 12:16:57 +0200398 master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200399 id: $MINION_ID
400 EOF
401}
402
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200403install_reclass()
404{
405 VERSION=${1:-$RECLASS_VERSION}
Petr Michalec372fa032017-11-15 17:36:19 +0100406 VERSION=${VERSION:-pkg}
Petr Michalec800dd072017-11-15 17:19:26 +0100407 case ${VERSION} in
408 pkg|package)
409 which reclass || $SUDO $PKGTOOL install -y reclass
rootb9e5d7c2018-03-17 12:12:44 +0000410 which reclass-salt || {
411 if [ -e /usr/share/reclass/reclass-salt ]; then
Petr Michalec6ba1c362018-03-17 15:01:51 +0100412 ln -fs /usr/share/reclass/reclass-salt /usr/bin
rootb9e5d7c2018-03-17 12:12:44 +0000413 fi
414 }
Petr Michalec800dd072017-11-15 17:19:26 +0100415 ;;
416 *)
Petr Michalec981f3cc2017-11-15 17:40:31 +0100417 log_warn "Install development version of reclass"
Petr Michalec1b37d3d2017-11-15 18:20:46 +0100418 # Note: dev/git/pip version...
419 # It replaces all local reclass versions on system
420 # Required for reclass/git features:
421 # $SUDO $PKGTOOL install -y libffi-dev libgit2-dev || true
Petr Michalec800dd072017-11-15 17:19:26 +0100422 for s in $(python -c "import site; print(' '.join(site.getsitepackages()))"); do
Petr Michalec23020832017-11-15 17:34:49 +0100423 sudo -H pip install --install-option="--prefix=" --upgrade --force-reinstall -I \
Petr Michalec800dd072017-11-15 17:19:26 +0100424 -t "$s" git+https://github.com/salt-formulas/reclass.git@${VERSION};
425 done
426 ;;
427 esac
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200428}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200429
430install_salt_master_pkg()
431{
432 echo -e "\nPreparing base OS repository ...\n"
433
434 configure_pkg_repo
435
436 echo -e "\nInstalling salt master ...\n"
437
438 case $PLATFORM_FAMILY in
439 debian)
440 $SUDO apt-get install -y git
alexz0adc2712018-02-11 17:33:52 +0100441 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200442 ;;
443 rhel)
444 yum install -y git
alexz0adc2712018-02-11 17:33:52 +0100445 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200446 ;;
447 esac
Jakub Josef0b611742018-01-09 17:02:01 +0100448
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200449 configure_salt_master
450
451 echo -e "\nRestarting services ...\n"
452 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
453 $SVCTOOL salt-master restart
454}
455
456install_salt_master_pip()
457{
458 echo -e "\nPreparing base OS repository ...\n"
459
460 case $PLATFORM_FAMILY in
461 debian)
462 $SUDO apt-get install -y python-pip python-dev zlib1g-dev git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200463 ;;
464 rhel)
465 $SUDO yum install -y git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200466 ;;
467 esac
468
469 echo -e "\nInstalling salt master ...\n"
470 # TODO: replace with saltstack bootstrap script
Jakub Josef0b611742018-01-09 17:02:01 +0100471
Petr Michalec88a95a22018-01-09 17:21:08 +0100472 if [ -z ${PIP_SALT_VERSION} ] || [ "$PIP_SALT_VERSION" == "latest" ]; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200473 pip install salt
474 else
Petr Michalec88a95a22018-01-09 17:21:08 +0100475 pip install salt==${PIP_SALT_VERSION}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200476 fi
477
478 curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master
479 ln -s /usr/local/bin/salt-master /usr/bin/salt-master
480
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200481 configure_salt_master
482
483 echo -e "\nRestarting services ...\n"
484 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
485 $SVCTOOL salt-master restart
486}
487
488
489
490install_salt_minion_pkg()
491{
492
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200493 echo -e "\nInstalling salt minion ...\n"
494
495 case $PLATFORM_FAMILY in
496 debian)
alexz0adc2712018-02-11 17:33:52 +0100497 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200498 ;;
499 rhel)
alexz0adc2712018-02-11 17:33:52 +0100500 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200501 ;;
502 esac
503
504
505 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200506 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200507}
508
509install_salt_minion_pip()
510{
511 echo -e "\nInstalling salt minion ...\n"
512
513 curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion
514 ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion
515
516 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200517 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200518}
519
azvyagintseve93f8372018-09-12 16:50:58 +0300520function install_salt_formula_pkg_all(){
521 log_warn "Installing and configuring ALL formulas ..."
522 if ! $SUDO apt-get install -y 'salt-formula-*'; then
523 echo -e "\nInstall ALL formulas by mask 'salt-formula-*' failed.\n"
524 exit 1
525 fi
526 for formula_service in $(ls ${FORMULAS_PATH}/reclass/service/); do
527 #Since some salt formula names contain "-" and in symlinks they should contain "_" adding replacement
528 formula_service=${formula_service//-/$'_'}
529 if [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ]; then
530 ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service}
531 fi
532 done
533}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200534
535install_salt_formula_pkg()
536{
537 configure_pkg_repo
538
539 case $PLATFORM_FAMILY in
540 debian)
541 echo "Configuring necessary formulas ..."
542
543 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
azvyagintseva7a91d52018-09-13 12:58:39 +0300544 if [[ ${EXTRA_FORMULAS_PKG_ALL} =~ ^(True|true|1|yes)$ ]]; then
azvyagintseve93f8372018-09-12 16:50:58 +0300545 install_salt_formula_pkg_all
546 return
547 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200548 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
Petr Michalec2d753972017-11-30 16:24:37 +0100549 [ -z ${FORMULAS_SALT_MASTER} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200550 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
551 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
552 [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \
553 if ! $SUDO apt-get install -y salt-formula-${formula_service}; then
554 echo -e "\nInstall salt-formula-${formula_service} failed.\n"
555 exit 1
556 fi
Oleksii Grudev691d4712018-04-02 10:23:46 +0300557 #Since some salt formula names contain "-" and in symlinks they should contain "_" adding replacement
558 formula_service=${formula_service//-/$'_'}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200559 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
560 ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service}
561 done
562 ;;
563 rhel)
564 # TODO
565 ;;
566 esac
567
568 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
569 [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo ""
570}
571
572install_salt_formula_git()
573{
574 echo "Configuring necessary formulas ..."
575
576 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
577 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
Petr Michalec2d753972017-11-30 16:24:37 +0100578 [ -z ${FORMULAS_SALT_MASTER} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200579 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
580 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
581 _BRANCH=${FORMULAS_BRANCH}
582 [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && {
583 if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then
584 # Fallback to the master branch if the branch doesn't exist for this repository
585 _BRANCH=master
586 fi
587 if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then
588 echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n"
589 exit 1
590 fi
591 } || {
592 cd ${FORMULAS_PATH}/env/_formulas/${formula_service};
593 git fetch origin/${_BRANCH} || git fetch --all
594 git checkout ${_BRANCH} && git pull || git pull;
595 cd -
596 }
597 [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \
598 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service}
599 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
600 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service}
601 done
602
603 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
604 [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo ""
605}
606
Petr Michalece9c84522017-12-13 17:14:08 +0100607saltservice_stop() {
Petr Michalecdd646db2017-12-18 15:56:18 +0100608 set +e
Petr Michalece9c84522017-12-13 17:14:08 +0100609 $SUDO service salt-minion stop
610 $SUDO service salt-master stop
611 sleep ${SALT_STOPSTART_WAIT:-30}
Petr Michalec7822efe2017-12-15 16:19:32 +0100612 ${SUDO} pkill -9 salt-master && ${SUDO} rm -rf /var/run/salt/master/* || true
Petr Michalece9c84522017-12-13 17:14:08 +0100613 ${SUDO} pkill -9 salt-minion
614}
615saltservice_start() {
Petr Michalecdd646db2017-12-18 15:56:18 +0100616 set +e
Petr Michalece9c84522017-12-13 17:14:08 +0100617 $SUDO service salt-master start
618 $SUDO service salt-minion start
619 sleep ${SALT_STOPSTART_WAIT:-30}
620}
621
622saltservice_restart() {
Petr Michalecdd646db2017-12-18 15:56:18 +0100623 set +e
Petr Michalece9c84522017-12-13 17:14:08 +0100624 saltservice_stop
625 saltservice_start
626}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200627
628saltmaster_bootstrap() {
629
630 log_info "Salt master setup"
631 test -n "$MASTER_HOSTNAME" || exit 1
632
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200633 # override some envs from cluster level *.env, use with care
634 source_local_envs
635
Petr Michalece9c84522017-12-13 17:14:08 +0100636 saltservice_stop
637
638 clone_reclass
639
projoke3c30e7d2017-10-19 17:15:40 +0800640 SCRIPTS=$(dirname $0)
Petr Michalece9c84522017-12-13 17:14:08 +0100641
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200642 test -e ${SCRIPTS}/.salt-master-setup.sh.passed || {
Adam Tengler035f24f2017-09-11 19:29:31 +0200643 export MASTER_IP=${MASTER_IP:-127.0.0.1}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200644 export MINION_ID=${MASTER_HOSTNAME}
645 if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
646 SALT_MASTER_SETUP_OUTPUT='/dev/stdout'
647 fi
648 # call local "setup() master"
649 #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then
650 if ! setup master; then
651 #cat /tmp/salt-master-setup.log
652 log_err "salt master setup() failed."
653 exit 1
654 else
655 $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed
656 fi
657 }
658
Petr Michalec981f3cc2017-11-15 17:40:31 +0100659 log_info "Install reclass"
660 install_reclass ${RECLASS_VERSION/dev*/develop}
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200661
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200662 log_info "Re/starting salt services"
Petr Michalece9c84522017-12-13 17:14:08 +0100663 saltservice_restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200664}
665
666# Init salt master
667saltmaster_init() {
668
669 log_info "Runing saltmaster states"
670 test -n "$MASTER_HOSTNAME" || exit 1
671
672 set -e
673 $SUDO salt-call saltutil.sync_all >/dev/null
674
Petr Michalecda014202017-08-18 11:26:07 +0200675 # workarond isolated and not fully bootstraped environments
Petr Michalec2801acb2017-10-31 15:00:15 +0100676 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
Petr Michalec54ee4082017-11-30 17:02:17 +0100677 SALT_MASTER_PILLAR='"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": '${RECLASS_IGNORE_CLASS_NOTFOUND:-False}', "ignore_class_regexp": ["service.*"]}}}},'
Petr Michalec2801acb2017-10-31 15:00:15 +0100678 fi
Petr Michalec8ce8a652017-11-30 15:39:20 +0100679 PILLAR='{'${SALT_MASTER_PILLAR}' "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalecda014202017-08-18 11:26:07 +0200680
Petr Michalec8b92d552017-11-29 12:28:50 +0100681 log_info "State: salt.master.env,salt.master.pillar"
Petr Michalec54ee4082017-11-30 17:02:17 +0100682 if ! $SUDO salt-call ${SALT_OPTS} state.apply salt.master.env,salt.master.pillar pillar="$PILLAR"; then
Petr Michalec85ef7ad2017-11-30 15:21:19 +0100683 log_err "State \`salt.master.env,salt.master.pillar pillar=$PILLAR\` failed, keep your eyes wide open!"
azvyagintseve3f6f402018-08-23 17:21:49 +0300684 if [[ $SA_IGNORE_ERROR_SALT_MASTER_ENV =~ ^(False|false|0|no)$ ]]; then
685 exit 1
686 fi
687
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200688 fi
689
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200690 # Revert temporary SaltMaster minimal configuration, if any
691 pushd $RECLASS_ROOT
692 if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then
Petr Michalec87778fc2017-11-02 10:13:25 +0100693 PILLAR='{"reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200694 git status || true
Petr Michalecda014202017-08-18 11:26:07 +0200695 log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200696 log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*."
697 git checkout -- $RECLASS_ROOT/nodes || true
698 log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state."
Petr Michalec7edf8322017-11-30 12:01:09 +0100699 log_info "State: salt.master.env,salt.master.pillar"
Petr Michalec54ee4082017-11-30 17:02:17 +0100700 if ! $SUDO salt-call ${SALT_OPTS} state.apply salt.master.env,salt.master.pillar pillar="$PILLAR"; then
Petr Michalec85ef7ad2017-11-30 15:21:19 +0100701 log_err "State \`salt.master.env,salt.master.pillar pillar=$PILLAR\` failed, keep your eyes wide open!"
azvyagintseve3f6f402018-08-23 17:21:49 +0300702 if [[ $SA_IGNORE_ERROR_SALT_MASTER_ENV =~ ^(False|false|0|no)$ ]]; then
703 exit 1
704 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200705 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200706 fi
707 popd
708
Petr Michalecda014202017-08-18 11:26:07 +0200709 # finally re-configure salt master conf, ie: may remove ignore_class_notfound option
710 log_info "State: salt.master.service"
Jakub Josef32563412018-01-17 17:55:05 +0100711 # ensure salt master is started
712 saltservice_start
Petr Michalec9fec8b32017-10-05 14:46:42 +0200713 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true
Petr Michalec4f043772017-12-19 15:40:54 +0100714 saltservice_start
Petr Michalecda014202017-08-18 11:26:07 +0200715
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200716 log_info "State: salt.master.storage.node"
717 set +e
Petr Michalec7edf8322017-11-30 12:01:09 +0100718 # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
719 # FIXME: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
Petr Michalec9fec8b32017-10-05 14:46:42 +0200720 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200721 ret=$?
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200722
Petr Michalecdd646db2017-12-18 15:56:18 +0100723 set -e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200724 if [[ $ret -eq 2 ]]; then
725 log_err "State reclass.storage.node failed with exit code 2 but continuing."
726 elif [[ $ret -ne 0 ]]; then
727 log_err "State reclass.storage.node failed with exit code $ret"
728 exit 1
729 fi
730
Petr Michalecdd646db2017-12-18 15:56:18 +0100731 set +e
732 log_info "Updating minion.conf -> master: localhost"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200733 $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf
Petr Michalecdd646db2017-12-18 15:56:18 +0100734
735 log_info "Re/starting salt services" # in order to load new deployed configuration from model
Petr Michalece9c84522017-12-13 17:14:08 +0100736 saltservice_restart
Petr Michalecdd646db2017-12-18 15:56:18 +0100737
738 log_info "Salt Util sync all"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200739 $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null
740
741 verify_salt_master
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200742
743}
744
Petr Michalec71e32682018-03-22 08:34:34 +0100745## CI Workarounds
746
747function mockup_node_registration() {
748
749 # for dynamic nodes registrations (require github.com/salt-formulas/salt-formula-reclass)
750
751 source /etc/os-release
752 os_codename=$VERSION_CODENAME
753 domain=$(hostname -d)
754 master_ip=$(hostname -I | awk '{print $1}')
755 fake_ip_preffix=$(echo $master_ip | awk -F. '{print $1"."$2}')
756 fake_ip_base=10
757
758 # SHOULD BE ALREADY RUN AS A PART OF BOOTSTRAP
759 # sync, in order to load custom modules
760 #salt-call saltutil.sync_all
761
762 # SHOULD BE ALREADY RUN AS A PART OF BOOTSTRAP
763 #PILLAR='{"reclass":{"storage":{"data_source":{"engine":"local"}}} }'
764 #salt-call state.apply reclass.storage.node pillar="$PILLAR" > /dev/null 2>/dev/null || true
765
766 # rotate over dynamic hosts
767 for host_idx in {01..02};do
768 for host in `salt-call pillar.items reclass:storage |grep '<<node_hostname>>' | awk -F_ '{print $NF}' | sed 's/[0-9]*//g' | egrep -v cfg | sort -u`; do
769 hostname=${host}${host_idx}
770 fake_ip_base=$(($fake_ip_base + 1))
771
772 node_network01_ip="$fake_ip_preffix.11.$fake_ip_base"
773 node_network02_ip="$fake_ip_preffix.12.$fake_ip_base"
774 node_network03_ip="$fake_ip_preffix.13.$fake_ip_base"
775 node_network04_ip="$fake_ip_preffix.14.$fake_ip_base"
776 node_network05_ip="$fake_ip_preffix.15.$fake_ip_base"
777 node_network01_iface=$(ls /sys/class/net/ | grep -v lo | sort | head -n1)
778 node_network02_iface="eth1"
779 node_network03_iface="eth2"
780 node_network04_iface="eth3"
781 node_network05_iface="eth4"
782
783 declare -A vars
784 vars=(
785 ["node_master_ip"]=
786 ["node_os"]=${os_codename}
787 ["node_deploy_ip"]=${node_network01_ip}
788 ["node_deploy_iface"]=${node_network01_iface}
789 ["node_control_ip"]=${node_network02_ip}
790 ["node_control_iface"]=${node_network02_iface}
791 ["node_tenant_ip"]=${node_network03_ip}
792 ["node_tenant_iface"]=${node_network03_iface}
793 ["node_external_ip"]=${node_network04_ip}
794 ["node_external_iface"]=${node_network04_iface}
795 ["node_baremetal_ip"]=${node_network05_ip}
796 ["node_baremetal_iface"]=${node_network05_iface}
797 ["node_domain"]=$domain
798 ["node_cluster"]=$(hostname -d |awk -F. '{print $1}')
799 ["node_hostname"]=$hostname
800 )
801
802 data=""; i=0
803 for key in "${!vars[@]}"; do
804 data+="\"${key}\": \"${vars[${key}]}\""
805 i=$(($i+1))
806 if [ $i -lt ${#vars[@]} ]; then
807 data+=", "
808 fi
809 done
810 echo "Classifying node $hostname"
811 NODECR='"node_name": "'${hostname}.${domain}'", "node_data": {'$data'}'
812 PILLAR='{'${NODECR}', "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
813 salt-call state.apply reclass.reactor_sls.node_register pillar="$PILLAR" #-l info
814 #salt-call event.send "reclass/minion/classify" "{$data}"
815 done
816 done
817
818}
819
820## VERIFY
821
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200822
823function verify_salt_master() {
824 set -e
825
826 log_info "Verify Salt master"
827 test -n "$MASTER_HOSTNAME" || exit 1
828
829 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
Petr Michaleca5141342017-08-16 12:55:20 +0200830 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml
831 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200832 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles
833 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state
834 $SUDO salt-call --no-color grains.items
835 $SUDO salt-call --no-color pillar.data
836 fi
Petr Michaleca5141342017-08-16 12:55:20 +0200837 # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_*
Petr Michalec6e40efc2018-03-22 09:47:47 +0100838 if ! $SUDO python -m reclass.cli --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200839 log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo"
840 exit 1
841 fi
Petr Michalec7edf8322017-11-30 12:01:09 +0100842 set +e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200843}
844
845function verify_salt_minion() {
846 set -e
847 node=$1
848 log_info "Verifying ${node}"
849 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
850 $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles
851 $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate
852 fi
Petr Michalec6e40efc2018-03-22 09:47:47 +0100853 if ! $SUDO python -m reclass.cli --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200854 log_err "For more details see full log /tmp/${node}.reclass.nodeinfo"
855 if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then
856 exit 1
857 fi
858 fi
Petr Michalec7edf8322017-11-30 12:01:09 +0100859 set +e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200860}
861
862function verify_salt_minions() {
863 #set -e
Petr Michalec679f15b2017-09-18 16:16:29 +0200864 NODES=$(find $RECLASS_ROOT/nodes/_generated/ -name "*.yml" | grep -v "cfg")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200865 log_info "Verifying minions: $(echo ${NODES}|xargs)"
866
867 # Parallel
868 #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify"
869 #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30
870
871 function filterFails() {
872 grep -v '/grains' | tee -a $1 | tail -n20
873 }
874
875 log_info "Verify nodes"
876 passed=0
877 for node in ${NODES}; do
878 node=$(basename $node .yml)
879
880 # filter first in cluster.. ctl-01, mon-01, etc..
881 if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then
882 verify_salt_minion ${node} || continue
883 else
884 echo Skipped $node.
885 fi
886 passed=$(($passed+1))
887 done
888 # fail on failures
889 total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l)
890 test ! $passed -lt $total || log_err "Results: $passed of $total passed."
891 test ! $passed -lt $total || {
892 tail -n50 /tmp/*.pillar_verify
893 return 1
894 }
Petr Michalec7edf8322017-11-30 12:01:09 +0100895 #set +e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200896}
897
898
899
900##########################################
901# To install salt master/minon
902
903function install() {
904 setup $@
905}
906
907function setup() {
908 # CLI
909 while [ x"$1" != x"" ]; do
910 which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null
911
912 case $1 in
913 master )
914 install_salt_master_$SALT_SOURCE
915 install_salt_minion_$SALT_SOURCE
916 install_salt_formula_$FORMULAS_SOURCE
917 ;;
918 minion )
919 install_salt_minion_$SALT_SOURCE
920 ;;
921 esac
922 shift
923 done
924 echo DONE
925}
926
927function bootstrap() {
928 log_info "Bootstrap & verification of SaltMaster and configured minions."
929 trap _atexit INT TERM EXIT
930
931 system_config_master
932 saltmaster_bootstrap &&\
Petr Michalec58575b92017-08-20 10:42:25 +0200933 saltmaster_init #&&\
Petr Michaleca5141342017-08-16 12:55:20 +0200934 #verify_salt_minions
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200935}
936
937function default() {
938 bootstrap $@
939}
940
941
942##########################################
azvyagintseve93f8372018-09-12 16:50:58 +0300943log_info "Running version: ${__ScriptVersion}"
944log_info "Command line: '${__ScriptFullName} ${__ScriptArgs}'"
945
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200946[[ "$0" != "$BASH_SOURCE" ]] || {
947# unless file is being sourced
948 default $@
949}